Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/generic/driver.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -599,29 +599,16 @@
 }
 
-/** Create session with the parent function.
- *
- * The session will be automatically closed when @a dev is destroyed.
- *
- * @param dev Device
- *
- * @return New session or NULL if session could not be created
- *
- */
-async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *dev)
-{
-	assert(dev->parent_sess == NULL);
-	dev->parent_sess = devman_parent_device_connect(dev->handle,
-	    IPC_FLAG_BLOCKING);
-
-	return dev->parent_sess;
-}
-
 /** Return existing session with the parent function.
  *
  * @param dev	Device
- * @return	Existing session or NULL if there is no session
+ * @return	Session with parent function or NULL upon failure
  */
 async_sess_t *ddf_dev_parent_sess_get(ddf_dev_t *dev)
 {
+	if (dev->parent_sess == NULL) {
+		dev->parent_sess = devman_parent_device_connect(dev->handle,
+		    IPC_FLAG_BLOCKING);
+	}
+
 	return dev->parent_sess;
 }
@@ -943,11 +930,15 @@
 	int rc = async_create_port(INTERFACE_DDF_DRIVER, driver_connection_driver,
 	    NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("Error: Failed to create driver port.\n");
 		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_DDF_DEVMAN, driver_connection_devman,
 	    NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("Error: Failed to create devman port.\n");
 		return rc;
+	}
 	
 	async_set_fallback_port_handler(driver_connection_client, NULL);
@@ -964,6 +955,8 @@
 	/* Return success from the task since server has started. */
 	rc = task_retval(0);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("Error: Failed returning task value.\n");
 		return rc;
+	}
 	
 	async_manager();
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/generic/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,13 +44,13 @@
 
 int register_interrupt_handler(ddf_dev_t *dev, int irq,
-    interrupt_handler_t *handler, const irq_code_t *pseudocode)
+    interrupt_handler_t *handler, const irq_code_t *irq_code)
 {
-	return async_irq_subscribe(irq, dev->handle,
-	    (async_notification_handler_t) handler, dev, pseudocode);
+	return async_irq_subscribe(irq, (async_notification_handler_t) handler,
+	    dev, irq_code);
 }
 
-int unregister_interrupt_handler(ddf_dev_t *dev, int irq)
+int unregister_interrupt_handler(ddf_dev_t *dev, int cap)
 {
-	return async_irq_unsubscribe(irq, dev->handle);
+	return async_irq_unsubscribe(cap);
 }
 
Index: uspace/lib/drv/generic/remote_hw_res.c
===================================================================
--- uspace/lib/drv/generic/remote_hw_res.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/generic/remote_hw_res.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,4 +45,8 @@
 static void remote_hw_res_enable_interrupt(ddf_fun_t *, void *, ipc_callid_t,
     ipc_call_t *);
+static void remote_hw_res_disable_interrupt(ddf_fun_t *, void *, ipc_callid_t,
+    ipc_call_t *);
+static void remote_hw_res_clear_interrupt(ddf_fun_t *, void *, ipc_callid_t,
+    ipc_call_t *);
 static void remote_hw_res_dma_channel_setup(ddf_fun_t *, void *, ipc_callid_t,
     ipc_call_t *);
@@ -53,4 +57,6 @@
 	[HW_RES_GET_RESOURCE_LIST] = &remote_hw_res_get_resource_list,
 	[HW_RES_ENABLE_INTERRUPT] = &remote_hw_res_enable_interrupt,
+	[HW_RES_DISABLE_INTERRUPT] = &remote_hw_res_disable_interrupt,
+	[HW_RES_CLEAR_INTERRUPT] = &remote_hw_res_clear_interrupt,
 	[HW_RES_DMA_CHANNEL_SETUP] = &remote_hw_res_dma_channel_setup,
 	[HW_RES_DMA_CHANNEL_REMAIN] = &remote_hw_res_dma_channel_remain,
@@ -67,10 +73,42 @@
 	hw_res_ops_t *hw_res_ops = (hw_res_ops_t *) ops;
 	
-	if (hw_res_ops->enable_interrupt == NULL)
+	if (hw_res_ops->enable_interrupt == NULL) {
 		async_answer_0(callid, ENOTSUP);
-	else if (hw_res_ops->enable_interrupt(fun))
-		async_answer_0(callid, EOK);
-	else
-		async_answer_0(callid, EREFUSED);
+		return;
+	}
+	
+	const int irq = DEV_IPC_GET_ARG1(*call);
+	const int ret = hw_res_ops->enable_interrupt(fun, irq);
+	async_answer_0(callid, ret);
+}
+
+static void remote_hw_res_disable_interrupt(ddf_fun_t *fun, void *ops,
+    ipc_callid_t callid, ipc_call_t *call)
+{
+	hw_res_ops_t *hw_res_ops = (hw_res_ops_t *) ops;
+	
+	if (hw_res_ops->disable_interrupt == NULL) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+	
+	const int irq = DEV_IPC_GET_ARG1(*call);
+	const int ret = hw_res_ops->disable_interrupt(fun, irq);
+	async_answer_0(callid, ret);
+}
+
+static void remote_hw_res_clear_interrupt(ddf_fun_t *fun, void *ops,
+    ipc_callid_t callid, ipc_call_t *call)
+{
+	hw_res_ops_t *hw_res_ops = (hw_res_ops_t *) ops;
+	
+	if (hw_res_ops->clear_interrupt == NULL) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+	
+	const int irq = DEV_IPC_GET_ARG1(*call);
+	const int ret = hw_res_ops->enable_interrupt(fun, irq);
+	async_answer_0(callid, ret);
 }
 
Index: uspace/lib/drv/include/ddf/driver.h
===================================================================
--- uspace/lib/drv/include/ddf/driver.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/include/ddf/driver.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -117,5 +117,4 @@
 extern devman_handle_t ddf_dev_get_handle(ddf_dev_t *);
 extern const char *ddf_dev_get_name(ddf_dev_t *);
-extern async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *);
 extern async_sess_t *ddf_dev_parent_sess_get(ddf_dev_t *);
 extern ddf_fun_t *ddf_fun_create(ddf_dev_t *, fun_type_t, const char *);
Index: uspace/lib/drv/include/ddf/interrupt.h
===================================================================
--- uspace/lib/drv/include/ddf/interrupt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/include/ddf/interrupt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 
 #include <libarch/common.h>
-#include <libarch/types.h>
+#include <types/common.h>
 #include <abi/ddi/irq.h>
 #include <adt/list.h>
Index: uspace/lib/drv/include/ops/hw_res.h
===================================================================
--- uspace/lib/drv/include/ops/hw_res.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/drv/include/ops/hw_res.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,7 @@
 typedef struct {
 	hw_resource_list_t *(*get_resource_list)(ddf_fun_t *);
-	bool (*enable_interrupt)(ddf_fun_t *);
+	int (*enable_interrupt)(ddf_fun_t *, int);
+	int (*disable_interrupt)(ddf_fun_t *, int);
+	int (*clear_interrupt)(ddf_fun_t *, int);
 	int (*dma_channel_setup)(ddf_fun_t *, unsigned, uint32_t, uint32_t, uint8_t);
 	int (*dma_channel_remain)(ddf_fun_t *, unsigned, size_t *);
Index: uspace/lib/ext4/src/directory_index.c
===================================================================
--- uspace/lib/ext4/src/directory_index.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/ext4/src/directory_index.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,4 @@
 #include <errno.h>
 #include <mem.h>
-#include <sort.h>
 #include <stdlib.h>
 #include <str.h>
@@ -668,5 +667,4 @@
  * @param arg1  First entry
  * @param arg2  Second entry
- * @param dummy Unused parameter, can be NULL
  *
  * @return Classic compare result
@@ -674,8 +672,9 @@
  *
  */
-static int ext4_directory_dx_entry_comparator(void *arg1, void *arg2, void *dummy)
-{
-	ext4_dx_sort_entry_t *entry1 = arg1;
-	ext4_dx_sort_entry_t *entry2 = arg2;
+static int ext4_directory_dx_entry_comparator(const void *arg1,
+    const void *arg2)
+{
+	ext4_dx_sort_entry_t const *entry1 = arg1;
+	ext4_dx_sort_entry_t const *entry2 = arg2;
 	
 	if (entry1->hash == entry2->hash)
@@ -793,5 +792,5 @@
 	/* Sort all entries */
 	qsort(sort_array, idx, sizeof(ext4_dx_sort_entry_t),
-	    ext4_directory_dx_entry_comparator, NULL);
+	    ext4_directory_dx_entry_comparator);
 	
 	/* Allocate new block for store the second part of entries */
Index: uspace/lib/fdisk/Makefile
===================================================================
--- uspace/lib/fdisk/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/fdisk/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,4 @@
 
 SOURCES = \
-	src/cap.c \
 	src/fdisk.c
 
Index: uspace/lib/fdisk/include/fdisk.h
===================================================================
--- uspace/lib/fdisk/include/fdisk.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/fdisk/include/fdisk.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 #include <loc.h>
 #include <types/fdisk.h>
+#include <types/vol.h>
 
 extern int fdisk_create(fdisk_t **);
@@ -48,5 +49,5 @@
 extern int fdisk_dev_info_get_svcname(fdisk_dev_info_t *, char **);
 extern void fdisk_dev_info_get_svcid(fdisk_dev_info_t *, service_id_t *);
-extern int fdisk_dev_info_capacity(fdisk_dev_info_t *, fdisk_cap_t *);
+extern int fdisk_dev_info_capacity(fdisk_dev_info_t *, cap_spec_t *);
 
 extern int fdisk_dev_open(fdisk_t *, service_id_t, fdisk_dev_t **);
@@ -55,5 +56,5 @@
 extern void fdisk_dev_get_flags(fdisk_dev_t *, fdisk_dev_flags_t *);
 extern int fdisk_dev_get_svcname(fdisk_dev_t *, char **);
-extern int fdisk_dev_capacity(fdisk_dev_t *, fdisk_cap_t *);
+extern int fdisk_dev_capacity(fdisk_dev_t *, cap_spec_t *);
 
 extern int fdisk_label_get_info(fdisk_dev_t *, fdisk_label_info_t *);
@@ -64,6 +65,6 @@
 extern fdisk_part_t *fdisk_part_next(fdisk_part_t *);
 extern int fdisk_part_get_info(fdisk_part_t *, fdisk_part_info_t *);
-extern int fdisk_part_get_max_avail(fdisk_dev_t *, fdisk_spc_t, fdisk_cap_t *);
-extern int fdisk_part_get_tot_avail(fdisk_dev_t *, fdisk_spc_t, fdisk_cap_t *);
+extern int fdisk_part_get_max_avail(fdisk_dev_t *, fdisk_spc_t, cap_spec_t *);
+extern int fdisk_part_get_tot_avail(fdisk_dev_t *, fdisk_spc_t, cap_spec_t *);
 extern int fdisk_part_create(fdisk_dev_t *, fdisk_part_spec_t *,
     fdisk_part_t **);
@@ -71,13 +72,10 @@
 extern void fdisk_pspec_init(fdisk_part_spec_t *);
 
-extern int fdisk_cap_format(fdisk_cap_t *, char **);
-extern int fdisk_cap_parse(const char *, fdisk_cap_t *);
-extern void fdisk_cap_simplify(fdisk_cap_t *);
-extern void fdisk_cap_from_blocks(uint64_t, size_t, fdisk_cap_t *);
-extern int fdisk_cap_to_blocks(fdisk_cap_t *, fdisk_cvsel_t, size_t, uint64_t *);
-
 extern int fdisk_ltype_format(label_type_t, char **);
 extern int fdisk_fstype_format(vol_fstype_t, char **);
 extern int fdisk_pkind_format(label_pkind_t, char **);
+
+extern int fdisk_get_vollabel_support(fdisk_dev_t *, vol_fstype_t,
+    vol_label_supp_t *);
 
 #endif
Index: uspace/lib/fdisk/include/types/fdisk.h
===================================================================
--- uspace/lib/fdisk/include/types/fdisk.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/fdisk/include/types/fdisk.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 
 #include <adt/list.h>
+#include <cap.h>
 #include <loc.h>
 #include <stdint.h>
@@ -43,28 +44,4 @@
 #include <types/vol.h>
 #include <vbd.h>
-#include <vol.h>
-
-/** Capacity unit */
-typedef enum {
-	cu_byte = 0,
-	cu_kbyte,
-	cu_mbyte,
-	cu_gbyte,
-	cu_tbyte,
-	cu_pbyte,
-	cu_ebyte,
-	cu_zbyte,
-	cu_ybyte
-} fdisk_cunit_t;
-
-/** Which of values within the precision of the capacity */
-typedef enum {
-	/** The nominal (middling) value */
-	fcv_nom,
-	/** The minimum value */
-	fcv_min,
-	/** The maximum value */
-	fcv_max
-} fdisk_cvsel_t;
 
 typedef enum {
@@ -86,25 +63,4 @@
 
 #define CU_LIMIT (cu_ybyte + 1)
-
-/** Partition capacity.
- *
- * Partition capacity represents both value and precision.
- * It is a decimal floating point value combined with a decimal
- * capacity unit. There is an integer mantisa @c m which in combination
- * with the number of decimal positions @c dp gives a decimal floating-point
- * number. E.g. for m = 1025 and dp = 2 the number is 10.25. If the unit
- * cunit = cu_kbyte, the capacity is 10.25 kByte, i.e. 10 250 bytes.
- *
- * Note that 1.000 kByte is equivalent to 1000 Byte, but 1 kByte is less
- * precise.
- */
-typedef struct {
-	/** Mantisa */
-	uint64_t m;
-	/** Decimal positions */
-	unsigned dp;
-	/** Capacity unit */
-	fdisk_cunit_t cunit;
-} fdisk_cap_t;
 
 /** List of devices available for managing by fdisk */
@@ -170,5 +126,5 @@
 	link_t llog_ba;
 	/** Capacity */
-	fdisk_cap_t capacity;
+	cap_spec_t capacity;
 	/** Partition kind */
 	label_pkind_t pkind;
@@ -187,4 +143,6 @@
 	/** Service ID */
 	service_id_t svc_id;
+	/** Volume label */
+	char *label;
 } fdisk_part_t;
 
@@ -192,9 +150,11 @@
 typedef struct {
 	/** Desired capacity */
-	fdisk_cap_t capacity;
+	cap_spec_t capacity;
 	/** Partition kind */
 	label_pkind_t pkind;
 	/** File system type */
 	vol_fstype_t fstype;
+	/** Volume label */
+	char *label;
 } fdisk_part_spec_t;
 
@@ -202,5 +162,5 @@
 typedef struct {
 	/** Capacity */
-	fdisk_cap_t capacity;
+	cap_spec_t capacity;
 	/** Partition kind */
 	label_pkind_t pkind;
@@ -209,4 +169,6 @@
 	/** File system type */
 	vol_fstype_t fstype;
+	/** Volume label */
+	char *label;
 } fdisk_part_info_t;
 
Index: uspace/lib/fdisk/src/fdisk.c
===================================================================
--- uspace/lib/fdisk/src/fdisk.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/fdisk/src/fdisk.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
 
 #include <adt/list.h>
+#include <cap.h>
 #include <errno.h>
 #include <fdisk.h>
@@ -218,5 +219,5 @@
 }
 
-int fdisk_dev_info_capacity(fdisk_dev_info_t *info, fdisk_cap_t *cap)
+int fdisk_dev_info_capacity(fdisk_dev_info_t *info, cap_spec_t *cap)
 {
 	vbd_disk_info_t vinfo;
@@ -227,5 +228,5 @@
 		return EIO;
 
-	fdisk_cap_from_blocks(vinfo.nblocks, vinfo.block_size, cap);
+	cap_from_blocks(vinfo.nblocks, vinfo.block_size, cap);
 	return EOK;
 }
@@ -269,4 +270,5 @@
 		part->pcnt = vpinfo.pcnt;
 		part->fstype = vpinfo.fstype;
+		part->label = str_dup(vpinfo.label);
 	}
 
@@ -293,5 +295,5 @@
 		dev->ext_part = part;
 
-	fdisk_cap_from_blocks(part->nblocks, dev->dinfo.block_size,
+	cap_from_blocks(part->nblocks, dev->dinfo.block_size,
 	    &part->capacity);
 	part->part_id = partid;
@@ -301,4 +303,6 @@
 	return EOK;
 error:
+	if (part != NULL)
+		free(part->label);
 	free(part);
 	return rc;
@@ -315,4 +319,6 @@
 	if (link_used(&part->llog_ba))
 		list_remove(&part->llog_ba);
+
+	free(part->label);
 	free(part);
 }
@@ -530,7 +536,7 @@
 }
 
-int fdisk_dev_capacity(fdisk_dev_t *dev, fdisk_cap_t *cap)
-{
-	fdisk_cap_from_blocks(dev->dinfo.nblocks, dev->dinfo.block_size, cap);
+int fdisk_dev_capacity(fdisk_dev_t *dev, cap_spec_t *cap)
+{
+	cap_from_blocks(dev->dinfo.nblocks, dev->dinfo.block_size, cap);
 	return EOK;
 }
@@ -667,9 +673,10 @@
 	info->fstype = part->fstype;
 	info->pkind = part->pkind;
+	info->label = part->label;
 	return EOK;
 }
 
 /** Get size of largest free block. */
-int fdisk_part_get_max_avail(fdisk_dev_t *dev, fdisk_spc_t spc, fdisk_cap_t *cap)
+int fdisk_part_get_max_avail(fdisk_dev_t *dev, fdisk_spc_t spc, cap_spec_t *cap)
 {
 	int rc;
@@ -690,5 +697,5 @@
 	}
 
-	fdisk_cap_from_blocks(nb, dev->dinfo.block_size, cap);
+	cap_from_blocks(nb, dev->dinfo.block_size, cap);
 	return EOK;
 }
@@ -696,5 +703,5 @@
 /** Get total free space capacity. */
 int fdisk_part_get_tot_avail(fdisk_dev_t *dev, fdisk_spc_t spc,
-    fdisk_cap_t *cap)
+    cap_spec_t *cap)
 {
 	fdisk_free_range_t fr;
@@ -718,5 +725,5 @@
 	} while (fdisk_free_range_next(&fr));
 
-	fdisk_cap_from_blocks(totb, dev->dinfo.block_size, cap);
+	cap_from_blocks(totb, dev->dinfo.block_size, cap);
 	return EOK;
 }
@@ -725,34 +732,54 @@
     fdisk_part_t **rpart)
 {
-	fdisk_part_t *part;
+	fdisk_part_t *part = NULL;
 	vbd_part_spec_t vpspec;
-	vbd_part_id_t partid;
-	int rc;
+	vbd_part_id_t partid = 0;
+	vol_part_info_t vpinfo;
+	const char *label;
+	int rc;
+
+	label = pspec->label != NULL ? pspec->label : "";
 
 	rc = fdisk_part_spec_prepare(dev, pspec, &vpspec);
-	if (rc != EOK)
-		return EIO;
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
 
 	rc = vbd_part_create(dev->fdisk->vbd, dev->sid, &vpspec, &partid);
-	if (rc != EOK)
-		return EIO;
+	if (rc != EOK) {
+		rc = EIO;
+		goto error;
+	}
 
 	rc = fdisk_part_add(dev, partid, &part);
 	if (rc != EOK) {
-		/* Try rolling back */
-		(void) vbd_part_delete(dev->fdisk->vbd, partid);
-		return EIO;
+		rc = EIO;
+		goto error;
 	}
 
 	if (part->svc_id != 0) {
-		rc = vol_part_mkfs(dev->fdisk->vol, part->svc_id, pspec->fstype);
+		rc = vol_part_mkfs(dev->fdisk->vol, part->svc_id, pspec->fstype,
+		    label);
 		if (rc != EOK && rc != ENOTSUP) {
-			fdisk_part_remove(part);
-			(void) vbd_part_delete(dev->fdisk->vbd, partid);
-			return EIO;
-		}
-
-		part->pcnt = vpc_fs;
-		part->fstype = pspec->fstype;
+			rc = EIO;
+			goto error;
+		}
+
+		/* Get the real label value */
+		rc = vol_part_info(dev->fdisk->vol, part->svc_id, &vpinfo);
+		if (rc != EOK) {
+			rc = EIO;
+			goto error;
+		}
+
+		part->pcnt = vpinfo.pcnt;
+		part->fstype = vpinfo.fstype;
+		part->label = str_dup(vpinfo.label);
+
+		if (part->label == NULL) {
+			rc = EIO;
+			goto error;
+		}
 	}
 
@@ -760,4 +787,11 @@
 		*rpart = part;
 	return EOK;
+error:
+	/* Try rolling back */
+	if (part != NULL)
+		fdisk_part_remove(part);
+	if (partid != 0)
+		(void) vbd_part_delete(dev->fdisk->vbd, partid);
+	return rc;
 }
 
@@ -962,15 +996,15 @@
 	int rc;
 
-	rc = fdisk_cap_to_blocks(&pspec->capacity, fcv_nom, dev->dinfo.block_size,
+	rc = cap_to_blocks(&pspec->capacity, cv_nom, dev->dinfo.block_size,
 	    &nom_blocks);
 	if (rc != EOK)
 		return rc;
 
-	rc = fdisk_cap_to_blocks(&pspec->capacity, fcv_min, dev->dinfo.block_size,
+	rc = cap_to_blocks(&pspec->capacity, cv_min, dev->dinfo.block_size,
 	    &min_blocks);
 	if (rc != EOK)
 		return rc;
 
-	rc = fdisk_cap_to_blocks(&pspec->capacity, fcv_max, dev->dinfo.block_size,
+	rc = cap_to_blocks(&pspec->capacity, cv_max, dev->dinfo.block_size,
 	    &max_blocks);
 	if (rc != EOK)
@@ -981,5 +1015,5 @@
 	max_blocks = fdisk_ba_align_up(dev, max_blocks);
 
-	pcnt = -1;
+	pcnt = LPC_LIMIT;
 
 	switch (pspec->fstype) {
@@ -1000,5 +1034,5 @@
 	}
 
-	if (pcnt < 0)
+	if (pcnt == LPC_LIMIT)
 		return EINVAL;
 
@@ -1188,4 +1222,11 @@
 }
 
+/** Get volume label support. */
+int fdisk_get_vollabel_support(fdisk_dev_t *dev, vol_fstype_t fstype,
+    vol_label_supp_t *vlsupp)
+{
+	return vol_part_get_lsupp(dev->fdisk->vol, fstype, vlsupp);
+}
+
 /** @}
  */
Index: uspace/lib/fs/libfs.h
===================================================================
--- uspace/lib/fs/libfs.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/fs/libfs.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 
 #include <ipc/vfs.h>
-#include <sys/types.h>
+#include <offset.h>
 #include <async.h>
 #include <loc.h>
Index: uspace/lib/graph/graph.c
===================================================================
--- uspace/lib/graph/graph.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/graph/graph.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -469,11 +469,6 @@
 static void vs_update_damaged_region(visualizer_t *vs, ipc_callid_t iid, ipc_call_t *icall)
 {
-#ifdef __32_BITS__
 	sysarg_t x_offset = (IPC_GET_ARG5(*icall) >> 16);
 	sysarg_t y_offset = (IPC_GET_ARG5(*icall) & 0x0000ffff);
-#else
-	sysarg_t x_offset = (IPC_GET_ARG5(*icall) >> 32);
-	sysarg_t y_offset = (IPC_GET_ARG5(*icall) & 0xffffffff);
-#endif
 	
 	int rc = vs->ops.handle_damage(vs,
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/gui/window.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -677,4 +677,24 @@
 }
 
+int window_set_caption(window_t *win, const char *caption)
+{
+	char *cap;
+	
+	if (caption == NULL) {
+		win->caption = NULL;
+	} else {
+		cap = str_dup(caption);
+		if (cap == NULL)
+			return ENOMEM;
+		free(win->caption);
+		win->caption = cap;
+	}
+	
+	win->is_focused = false;
+	handle_refresh(win);
+	
+	return EOK;
+}
+
 void window_refresh(window_t *win)
 {
Index: uspace/lib/gui/window.h
===================================================================
--- uspace/lib/gui/window.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/gui/window.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -77,4 +77,7 @@
     window_placement_flags_t);
 
+/** Change window caption. */
+extern int window_set_caption(window_t *, const char *);
+
 /**
  * Post refresh event into event loop. Widget tree is traversed and all widgets
Index: uspace/lib/hound/include/hound/client.h
===================================================================
--- uspace/lib/hound/include/hound/client.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/hound/include/hound/client.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,4 @@
 
 #include <async.h>
-#include <stdbool.h>
 #include <pcm/format.h>
 #include <hound/protocol.h>
Index: uspace/lib/hound/src/client.c
===================================================================
--- uspace/lib/hound/src/client.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/hound/src/client.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,5 @@
 #include <stdlib.h>
 #include <stdio.h>
-#include <libarch/types.h>
+#include <types/common.h>
 #include <task.h>
 
@@ -48,5 +48,5 @@
 
 /** Stream structure */
-typedef struct hound_stream {
+struct hound_stream {
 	/** link in context's list */
 	link_t link;
@@ -59,5 +59,5 @@
 	/** Stream flags */
 	int flags;
-} hound_stream_t;
+};
 
 /**
@@ -72,5 +72,5 @@
 
 /** Hound client context structure */
-typedef struct hound_context {
+struct hound_context {
 	/** Audio session */
 	hound_sess_t *session;
@@ -89,5 +89,5 @@
 	/** Assigned context id */
 	hound_context_id_t id;
-} hound_context_t;
+};
 
 /**
Index: uspace/lib/hound/src/protocol.c
===================================================================
--- uspace/lib/hound/src/protocol.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/hound/src/protocol.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,5 @@
 #include <stdlib.h>
 #include <stdio.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 #include "protocol.h"
Index: uspace/lib/http/include/http/receive-buffer.h
===================================================================
--- uspace/lib/http/include/http/receive-buffer.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/http/include/http/receive-buffer.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 
 #include <adt/list.h>
+#include <stddef.h>
 
 /** Receive data.
Index: uspace/lib/http/src/http.c
===================================================================
--- uspace/lib/http/src/http.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/http/src/http.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -121,5 +121,8 @@
 	
 	tcp_conn_destroy(http->conn);
+	http->conn = NULL;
 	tcp_destroy(http->tcp);
+	http->tcp = NULL;
+	
 	return EOK;
 }
@@ -127,4 +130,5 @@
 void http_destroy(http_t *http)
 {
+	(void) http_close(http);
 	recv_buffer_fini(&http->recv_buffer);
 	free(http);
Index: uspace/lib/label/Makefile
===================================================================
--- uspace/lib/label/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/label/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,5 @@
 
 USPACE_PREFIX = ../..
-EXTRA_CFLAGS = -Iinclude -I$(LIBBLOCK_PREFIX)
+EXTRA_CFLAGS = -Iinclude
 
 LIBRARY = liblabel
@@ -34,7 +34,12 @@
 SOURCES = \
 	src/dummy.c \
+	src/empty.c \
 	src/mbr.c \
 	src/gpt.c \
 	src/label.c
 
+TEST_SOURCES = \
+	test/main.c \
+	test/label.c
+
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/label/include/label/empty.h
===================================================================
--- uspace/lib/label/include/label/empty.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/label/include/label/empty.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup liblabel
+ * @{
+ */
+/**
+ * @file
+ * @brief
+ */
+
+#ifndef LABEL_EMPTY_H_
+#define LABEL_EMPTY_H_
+
+#include <loc.h>
+#include <types/liblabel.h>
+
+extern int label_bd_is_empty(label_bd_t *, bool *);
+extern int label_bd_empty(label_bd_t *);
+extern int label_part_empty(label_part_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/label/include/label/label.h
===================================================================
--- uspace/lib/label/include/label/label.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/label/include/label/label.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup liblabel
+ * @{
+ */
+/**
+ * @file Disk label library.
+ */
+
+#ifndef LIBLABEL_LABEL_H_
+#define LIBLABEL_LABEL_H_
+
+#include <types/label.h>
+#include <types/liblabel.h>
+
+extern int label_open(label_bd_t *, label_t **);
+extern int label_create(label_bd_t *, label_type_t, label_t **);
+extern void label_close(label_t *);
+extern int label_destroy(label_t *);
+extern int label_get_info(label_t *, label_info_t *);
+
+extern label_part_t *label_part_first(label_t *);
+extern label_part_t *label_part_next(label_part_t *);
+extern void label_part_get_info(label_part_t *, label_part_info_t *);
+
+extern int label_part_create(label_t *, label_part_spec_t *,
+    label_part_t **);
+extern int label_part_destroy(label_part_t *);
+extern void label_pspec_init(label_part_spec_t *);
+extern int label_suggest_ptype(label_t *, label_pcnt_t, label_ptype_t *);
+
+#endif
+
+/** @}
+ */
